package gov.usgs.earthquake.nshmp.netcdf.reader;

import static com.google.common.base.Preconditions.checkState;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

import gov.usgs.earthquake.nshmp.geo.Location;

@SuppressWarnings("serial")
public class BoundingHazards extends LinkedHashMap<Location, StaticHazards> {

  public BoundingHazards() {}

  private BoundingHazards(Map<Location, StaticHazards> boundingHazards) {
    putAll(boundingHazards);
  }

  public static Builder builder() {
    return new Builder();
  }

  public static class Builder {
    Map<Location, StaticHazards> boundingHazards;

    private Builder() {
      boundingHazards = new HashMap<>();
    }

    public Builder put(Location location, StaticHazards staticHazards) {
      boundingHazards.put(location, staticHazards);
      return this;
    }

    public BoundingHazards build() {
      checkState(!boundingHazards.isEmpty(), "Must add hazards");
      return new BoundingHazards(boundingHazards);
    }

  }

}
