package gov.usgs.earthquake.nshmp.netcdf.reader;

import static com.google.common.base.Preconditions.checkState;

import java.util.EnumMap;

import gov.usgs.earthquake.nshmp.netcdf.SiteClass;

@SuppressWarnings("serial")
public class StaticHazards extends EnumMap<SiteClass, StaticHazard> {

  public StaticHazards() {
    super(SiteClass.class);
  }

  private StaticHazards(EnumMap<SiteClass, StaticHazard> staticHazards) {
    super(SiteClass.class);
    this.putAll(staticHazards);
  }

  public static Builder builder() {
    return new Builder();
  }

  public static class Builder {
    EnumMap<SiteClass, StaticHazard> staticHazards;

    private Builder() {
      staticHazards = new EnumMap<>(SiteClass.class);
    }

    public Builder put(SiteClass siteClass, StaticHazard staticHazard) {
      staticHazards.put(siteClass, staticHazard);
      return this;
    }

    public StaticHazards build() {
      checkState(!staticHazards.isEmpty(), "Must add hazards");
      return new StaticHazards(staticHazards);
    }

  }

}
